1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY
=$
(cd "$TEST_DIRECTORY" && pwd) ||
exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
36 # Similarly, override this to store the test-results subdir
38 TEST_OUTPUT_DIRECTORY
=$TEST_DIRECTORY
40 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev
/null
47 echo >&2 'error: you do not seem to have built git yet.'
51 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
58 # do not redirect again
60 *' --tee '*|
*' --va'*)
61 mkdir
-p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE
="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED
=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $?
> $BASE.
exit) |
tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
70 # For repeatability, reset the environment to known value.
76 export LANG LC_ALL PAGER TERM TZ
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
82 unset VISUAL EMAIL LANGUAGE COLUMNS $
("$PERL_PATH" -e '
84 my $ok = join("|", qw(
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
101 GIT_AUTHOR_EMAIL
=author@example.com
102 GIT_AUTHOR_NAME
='A U Thor'
103 GIT_COMMITTER_EMAIL
=committer@example.com
104 GIT_COMMITTER_NAME
='C O Mitter'
105 GIT_MERGE_VERBOSITY
=5
106 GIT_MERGE_AUTOEDIT
=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
112 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
114 GIT_INDEX_VERSION
="$TEST_GIT_INDEX_VERSION"
115 export GIT_INDEX_VERSION
118 # Add libc MALLOC and MALLOC_PERTURB test
119 # only if we are not executing the test with valgrind
120 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev
/null ||
121 test -n "$TEST_NO_MALLOC_CHECK"
123 setup_malloc_check
() {
126 teardown_malloc_check
() {
130 setup_malloc_check
() {
131 MALLOC_CHECK_
=3 MALLOC_PERTURB_
=165
132 export MALLOC_CHECK_ MALLOC_PERTURB_
134 teardown_malloc_check
() {
135 unset MALLOC_CHECK_ MALLOC_PERTURB_
139 # Protect ourselves from common misconfiguration to export
140 # CDPATH into the environment
146 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
148 echo "* warning: Some tests will not work if GIT_TRACE" \
149 "is set as to trace on STDERR ! *"
150 echo "* warning: Please set GIT_TRACE to something" \
151 "other than 1, 2 or true ! *"
157 # A regexp to match 5 and 40 hexdigits
158 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
159 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
162 _z40
=0000000000000000000000000000000000000000
168 export _x05 _x40 _z40 LF
170 # Each test should start with something like this, after copyright notices:
172 # test_description='Description of this test...
173 # This test checks if command xyzzy does the right thing...
176 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
177 TERM
=$ORIGINAL_TERM &&
180 tput bold
>/dev
/null
2>&1 &&
181 tput setaf
1 >/dev
/null
2>&1 &&
182 tput sgr0
>/dev
/null
2>&1
186 while test "$#" -ne 0
189 -d|
--d|
--de|
--deb|
--debu|
--debug)
191 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
192 immediate
=t
; shift ;;
193 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
194 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
196 shift; test "$#" -ne 0 ||
{
197 echo 'error: -r requires an argument' >&2;
200 run_list
=$1; shift ;;
202 run_list
=$
(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
203 -h|
--h|
--he|
--hel|
--help)
205 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
208 verbose_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
210 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
211 # Ignore --quiet under a TAP::Harness. Saying how many tests
212 # passed without the ok/not ok details is always an error.
213 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
215 with_dashes
=t
; shift ;;
218 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
222 valgrind
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
225 valgrind_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
228 shift ;; # was handled already
230 root
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
233 echo "error: unknown test option '$1'" >&2; exit 1 ;;
237 if test -n "$valgrind_only"
239 test -z "$valgrind" && valgrind
=memcheck
240 test -z "$verbose" && verbose_only
="$valgrind_only"
241 elif test -n "$valgrind"
254 tput bold
; tput setaf
1;; # bold red
256 tput setaf
4;; # blue
258 tput setaf
3;; # brown/yellow
260 tput setaf
2;; # green
262 tput setaf
6;; # cyan
264 test -n "$quiet" && return;;
274 test -z "$1" && test -n "$quiet" && return
281 say_color error
"error: $*"
290 test "${test_description}" != "" ||
291 error
"Test script did not set test_description."
293 if test "$help" = "t"
295 printf '%s\n' "$test_description"
301 if test "$verbose" = "t"
305 exec 4>/dev
/null
3>/dev
/null
314 test_external_has_tap
=0
318 if test -n "$GIT_EXIT_OK"
322 echo >&5 "FATAL: Unexpected exit with code $code"
330 # The user-facing functions are loaded from a separate file so that
331 # test_perf subshells can have them too
332 .
"$TEST_DIRECTORY/test-lib-functions.sh"
334 # You are not expected to call test_ok_ and test_failure_ directly, use
335 # the test_expect_* functions instead.
338 test_success
=$
(($test_success + 1))
339 say_color
"" "ok $test_count - $@"
343 test_failure
=$
(($test_failure + 1))
344 say_color error
"not ok $test_count - $1"
346 printf '%s\n' "$*" |
sed -e 's/^/# /'
347 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
350 test_known_broken_ok_
() {
351 test_fixed
=$
(($test_fixed+1))
352 say_color error
"ok $test_count - $@ # TODO known breakage vanished"
355 test_known_broken_failure_
() {
356 test_broken
=$
(($test_broken+1))
357 say_color warn
"not ok $test_count - $@ # TODO known breakage"
361 test "$debug" = "" ||
eval "$1"
364 match_pattern_list
() {
367 test -z "$*" && return 1
378 match_test_selector_list
() {
383 test -z "$1" && return 0
385 # Both commas and whitespace are accepted as separators.
391 # If the first selector is negative we include by default.
399 orig_selector
=$selector
405 selector
=${selector##?}
409 test -z "$selector" && continue
413 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev
/null
415 echo "error: $title: invalid non-numeric in range" \
416 "start: '$orig_selector'" >&2
419 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev
/null
421 echo "error: $title: invalid non-numeric in range" \
422 "end: '$orig_selector'" >&2
427 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev
/null
429 echo "error: $title: invalid non-numeric in test" \
430 "selector: '$orig_selector'" >&2
435 # Short cut for "obvious" cases
436 test -z "$include" && test -z "$positive" && continue
437 test -n "$include" && test -n "$positive" && continue
441 if test $arg -le ${selector#-}
447 if test $arg -ge ${selector%-}
453 if test ${selector%%-*} -le $arg \
454 && test $arg -le ${selector#*-}
460 if test $arg -eq $selector
471 maybe_teardown_verbose
() {
472 test -z "$verbose_only" && return
473 exec 4>/dev
/null
3>/dev
/null
478 maybe_setup_verbose
() {
479 test -z "$verbose_only" && return
480 if match_pattern_list
$test_count $verbose_only
483 # Emit a delimiting blank line when going from
484 # non-verbose to verbose. Within verbose mode the
485 # delimiter is printed by test_expect_*. The choice
486 # of the initial $last_verbose is such that before
487 # test 1, we do not print it.
488 test -z "$last_verbose" && echo >&3 ""
491 exec 4>/dev
/null
3>/dev
/null
494 last_verbose
=$verbose
497 maybe_teardown_valgrind
() {
498 test -z "$GIT_VALGRIND" && return
499 GIT_VALGRIND_ENABLED
=
502 maybe_setup_valgrind
() {
503 test -z "$GIT_VALGRIND" && return
504 if test -z "$valgrind_only"
506 GIT_VALGRIND_ENABLED
=t
509 GIT_VALGRIND_ENABLED
=
510 if match_pattern_list
$test_count $valgrind_only
512 GIT_VALGRIND_ENABLED
=t
517 # This is a separate function because some tests use
518 # "return" to end a test_expect_success block early.
519 eval </dev
/null
>&3 2>&4 "$*"
528 teardown_malloc_check
530 if test -z "$immediate" ||
test $eval_ret = 0 ||
test -n "$expecting_failure"
533 test_eval_
"$test_cleanup"
534 teardown_malloc_check
536 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
544 test_count
=$
(($test_count+1))
551 maybe_teardown_valgrind
552 maybe_teardown_verbose
558 if match_pattern_list
$this_test.
$test_count $GIT_SKIP_TESTS
561 skipped_reason
="GIT_SKIP_TESTS"
563 if test -z "$to_skip" && test -n "$test_prereq" &&
564 ! test_have_prereq
"$test_prereq"
569 if test "$missing_prereq" != "$test_prereq"
571 of_prereq
=" of $test_prereq"
573 skipped_reason
="missing $missing_prereq${of_prereq}"
575 if test -z "$to_skip" && test -n "$run_list" &&
576 ! match_test_selector_list
'--run' $test_count "$run_list"
579 skipped_reason
="--run"
584 say_color skip
>&3 "skipping test: $@"
585 say_color skip
"ok $test_count # skip $1 ($skipped_reason)"
594 # stub; perf-lib overrides it
595 test_at_end_hook_
() {
602 if test -z "$HARNESS_ACTIVE"
604 test_results_dir
="$TEST_OUTPUT_DIRECTORY/test-results"
605 mkdir
-p "$test_results_dir"
607 test_results_path
="$test_results_dir/${base%.sh}-$$.counts"
609 cat >>"$test_results_path" <<-EOF
611 success $test_success
619 if test "$test_fixed" != 0
621 say_color error
"# $test_fixed known breakage(s) vanished; please update test(s)"
623 if test "$test_broken" != 0
625 say_color warn
"# still have $test_broken known breakage(s)"
627 if test "$test_broken" != 0 ||
test "$test_fixed" != 0
629 test_remaining
=$
(( $test_count - $test_broken - $test_fixed ))
630 msg
="remaining $test_remaining test(s)"
632 test_remaining
=$test_count
633 msg
="$test_count test(s)"
635 case "$test_failure" in
637 # Maybe print SKIP message
638 if test -n "$skip_all" && test $test_count -gt 0
640 error
"Can't use skip_all after running some tests"
642 [ -z "$skip_all" ] || skip_all
=" # SKIP $skip_all"
644 if test $test_external_has_tap -eq 0
646 if test $test_remaining -gt 0
648 say_color pass
"# passed all $msg"
650 say
"1..$test_count$skip_all"
653 test -d "$remove_trash" &&
654 cd "$(dirname "$remove_trash")" &&
655 rm -rf "$(basename "$remove_trash")"
662 if test $test_external_has_tap -eq 0
664 say_color error
"# failed $test_failure among $msg"
673 if test -n "$valgrind"
677 test "$1" = "$(readlink "$2")" ||
{
685 while test -d "$2".lock
687 say
"Waiting for lock on $2."
694 make_valgrind_symlink
() {
695 # handle only executables, unless they are shell libraries that
696 # need to be in the exec-path.
698 test "# " = "$(head -c 2 <"$1")" ||
701 base
=$
(basename "$1")
702 symlink_target
=$GIT_BUILD_DIR/$base
703 # do not override scripts
704 if test -x "$symlink_target" &&
705 test ! -d "$symlink_target" &&
706 test "#!" != "$(head -c 2 < "$symlink_target")"
708 symlink_target
=..
/valgrind.sh
712 symlink_target
=..
/unprocessed-script
714 # create the link, or replace it if it is out of date
715 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
718 # override all git executables in TEST_DIRECTORY/..
719 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
720 mkdir
-p "$GIT_VALGRIND"/bin
721 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/test-
*
723 make_valgrind_symlink
$file
725 # special-case the mergetools loadables
726 make_symlink
"$GIT_BUILD_DIR"/mergetools
"$GIT_VALGRIND/bin/mergetools"
731 ls "$path"/git-
* 2> /dev
/null |
734 make_valgrind_symlink
"$file"
738 PATH
=$GIT_VALGRIND/bin
:$PATH
739 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
741 GIT_VALGRIND_MODE
="$valgrind"
742 export GIT_VALGRIND_MODE
743 GIT_VALGRIND_ENABLED
=t
744 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED
=
745 export GIT_VALGRIND_ENABLED
746 elif test -n "$GIT_TEST_INSTALLED"
748 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
749 error
"Cannot run git from $GIT_TEST_INSTALLED."
750 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
751 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
752 else # normal case, use ../bin-wrappers only unless $with_dashes:
753 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
754 if ! test -x "$git_bin_dir/git"
756 if test -z "$with_dashes"
758 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
762 PATH
="$git_bin_dir:$PATH"
763 GIT_EXEC_PATH
=$GIT_BUILD_DIR
764 if test -n "$with_dashes"
766 PATH
="$GIT_BUILD_DIR:$PATH"
769 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
770 GIT_CONFIG_NOSYSTEM
=1
772 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
774 if test -z "$GIT_TEST_CMP"
776 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
778 GIT_TEST_CMP
="$DIFF -c"
780 GIT_TEST_CMP
="$DIFF -u"
784 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
786 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
787 error
"You haven't built things yet, have you?"
790 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
792 echo >&2 'You need to build test-chmtime:'
793 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
798 TRASH_DIRECTORY
="trash directory.$(basename "$0" .sh)"
799 test -n "$root" && TRASH_DIRECTORY
="$root/$TRASH_DIRECTORY"
800 case "$TRASH_DIRECTORY" in
801 /*) ;; # absolute path is good
802 *) TRASH_DIRECTORY
="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
804 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
805 rm -fr "$TRASH_DIRECTORY" ||
{
807 echo >&5 "FATAL: Cannot prepare test area"
811 HOME
="$TRASH_DIRECTORY"
814 if test -z "$TEST_NO_CREATE_REPO"
816 test_create_repo
"$TRASH_DIRECTORY"
818 mkdir
-p "$TRASH_DIRECTORY"
820 # Use -P to resolve symlinks in our working directory so that the cwd
821 # in subprocesses like git equals our $PWD (for pathname comparisons).
822 cd -P "$TRASH_DIRECTORY" ||
exit 1
825 this_test
=${this_test%%-*}
826 if match_pattern_list
"$this_test" $GIT_SKIP_TESTS
828 say_color info
>&3 "skipping test $this_test altogether"
829 skip_all
="skip all tests in $this_test"
833 # Provide an implementation of the 'yes' utility
848 # Fix some commands on Windows
851 # Windows has its own (incompatible) sort and find
861 # git sees Windows-style pwd
865 # no POSIX permissions
866 # backslashes in pathspec are converted to '/'
867 # exec does not inherit the PID
868 test_set_prereq MINGW
869 test_set_prereq NOT_CYGWIN
870 test_set_prereq SED_STRIPS_CR
871 test_set_prereq GREP_STRIPS_CR
872 GIT_TEST_CMP
=mingw_test_cmp
875 test_set_prereq POSIXPERM
876 test_set_prereq EXECKEEPSPID
877 test_set_prereq NOT_MINGW
878 test_set_prereq CYGWIN
879 test_set_prereq SED_STRIPS_CR
880 test_set_prereq GREP_STRIPS_CR
883 test_set_prereq POSIXPERM
884 test_set_prereq BSLASHPSPEC
885 test_set_prereq EXECKEEPSPID
886 test_set_prereq NOT_MINGW
887 test_set_prereq NOT_CYGWIN
891 ( COLUMNS
=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
892 test -z "$NO_PERL" && test_set_prereq PERL
893 test -z "$NO_PYTHON" && test_set_prereq PYTHON
894 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
895 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
897 # Can we rely on git's output in the C locale?
898 if test -n "$GETTEXT_POISON"
900 GIT_GETTEXT_POISON
=YesPlease
901 export GIT_GETTEXT_POISON
902 test_set_prereq GETTEXT_POISON
904 test_set_prereq C_LOCALE_OUTPUT
907 # Use this instead of test_cmp to compare files that contain expected and
908 # actual output from git commands that can be translated. When running
909 # under GETTEXT_POISON this pretends that the command produced expected
912 test -n "$GETTEXT_POISON" || test_cmp
"$@"
915 # Use this instead of "grep expected-string actual" to see if the
916 # output from a git command that can be translated either contains an
917 # expected string, or does not contain an unwanted one. When running
918 # under GETTEXT_POISON this pretends that the command produced expected
921 if test -n "$GETTEXT_POISON"
924 elif test "x!" = "x$1"
933 test_lazy_prereq PIPE
'
934 # test whether the filesystem supports FIFOs
940 rm -f testfifo && mkfifo testfifo
945 test_lazy_prereq SYMLINKS
'
946 # test whether the filesystem supports symbolic links
947 ln -s x y && test -h y
950 test_lazy_prereq FILEMODE
'
951 test "$(git config --bool core.filemode)" = true
954 test_lazy_prereq CASE_INSENSITIVE_FS
'
955 echo good >CamelCase &&
956 echo bad >camelcase &&
957 test "$(cat CamelCase)" != good
960 test_lazy_prereq UTF8_NFD_TO_NFC
'
961 # check whether FS converts nfd unicode to nfc
962 auml=$(printf "\303\244")
963 aumlcdiar=$(printf "\141\314\210")
973 test_lazy_prereq AUTOIDENT
'
974 sane_unset GIT_AUTHOR_NAME &&
975 sane_unset GIT_AUTHOR_EMAIL &&
976 git var GIT_AUTHOR_IDENT
979 test_lazy_prereq EXPENSIVE
'
980 test -n "$GIT_TEST_LONG"
983 test_lazy_prereq USR_BIN_TIME
'
984 test -x /usr/bin/time
987 # When the tests are run as root, permission tests will report that
988 # things are writable when they shouldn't be.
989 test -w / || test_set_prereq SANITY
991 GIT_UNZIP
=${GIT_UNZIP:-unzip}
992 test_lazy_prereq UNZIP
'